/*	Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


#include "pile.h"

#define MAX(A,B) ((A) > (B) ? (A) : (B))

ut_Pile
ut_pile (size, alloc)
     int size;
     int alloc;
{
  ut_Pile result = (ut_Pile) ck_malloc (sizeof (*result));
  result->size = size;
  result->data = ck_malloc (size * alloc);
  result->alloced = alloc;
  result->used = 0;
  return result;
}

void *
ut_pile_read (p)
     ut_Pile p;
{
  return p->data;
}

void
ut_pile_unreserve (p, size)
     ut_Pile p;
     int size;
{
  p->used -= size;
}


void *
ut_pile_reserve (p, size)
     ut_Pile p;
     int size;
{
  if (size > (p->alloced - p->used))
    {
      int newsize = MAX (size + p->used, 2 * p->alloced);
      p->data = ck_realloc (p->data, p->size * newsize);
      p->alloced = newsize;
    }

  p->used += size;
  return (void *) ((char *) p->data + p->size * (p->used - size));
}

void
ut_pile_clear (p)
     ut_Pile p;
{
  p->used = 0;
}

void
ut_free_pile (p)
     ut_Pile p;
{
  ck_free (p->data);
  ck_free (p);
}
